//************************************************************************
//   Copyright (C) 2004-2006 Maxim I. Guisov                            //
//                                                                      //
// Permission to use, copy, modify, distribute and sell this software   //
// and its documentation for any purpose is hereby granted without fee, //
// provided that the above copyright notice appear in all copies and    //
// that both that copyright notice and this permission notice appear    //
// in supporting documentation. Author makes no representations         //
// about the suitability of this software for any purpose.              //
// It is provided "as is" without express or implied warranty.          //
//                                                                      //
//************************************************************************
#ifndef ESPACE_H_INCLUDED_
#define ESPACE_H_INCLUDED_

class IndexBoard;

// class represents set of adjacent empty points on the board
class ESpace: public Region
{
public:
    
    ESpace( int id, const Point& start, BoardNavigator* bnav );
    virtual ~ESpace() {}

    virtual void preprocess();
    virtual void update_props() {}

    IndexArray adjBlocks;
    IndexArray adjBlocksLiberties;

    bool in_question;

private:

    void Extend( const Point& pos );
};


#endif // ESPACE_H_INCLUDED_