//************************************************************************
//   Copyright (C) 2004-2006 Maxim I. Guisov                            //
//                                                                      //
// Permission to use, copy, modify, distribute and sell this software   //
// and its documentation for any purpose is hereby granted without fee, //
// provided that the above copyright notice appear in all copies and    //
// that both that copyright notice and this permission notice appear    //
// in supporting documentation. Author makes no representations         //
// about the suitability of this software for any purpose.              //
// It is provided "as is" without express or implied warranty.          //
//                                                                      //
//************************************************************************
#ifndef BLOCK_FEATURES_H_INCLUDED_
#define BLOCK_FEATURES_H_INCLUDED_

#include "..\\RPropNet\\RPropNet.h"

class BFeatures
{
public:

    const NetConfig &netConfig_;
    BFeatures( const NetConfig &netConfig ) : netConfig_( netConfig ) {}

    static void usePreset_( NetConfig &netConfig, const int S1i[], const int SNi[] );
    static void usePresetA( NetConfig &netConfig );
    static void usePresetB( NetConfig &netConfig );
    static void usePresetC( NetConfig &netConfig );
    static void usePresetD( NetConfig &netConfig );

    void fill( const Block& b, int iteration );

    enum tFeatureType {
        block_size = 0,
        block_perimeter,
        block_liberties_1,
        block_liberties_2,
        block_liberties_3,
        block_prot_liberties,
        block_chain_connections,
        block_opp_blocks_num,
        block_local_majority,
        block_cm_x,
        block_cm_y,
        block_bb_square,
        eye_num,
        eye_sum_size,
        eye_sum_perimeter,
        eye_sum_split_points_num,
        pacer_average_power,
        pacer_sum_acc_size,
        pacer_sum_acc_perimeter,
        pacer_sum_int_size,
        pacer_sum_int_perimeter,
        pacer_sum_int_split_points,
        opp_cer_size,
        opp_cer_perimeter,
        chain_blocks_num,
        chain_size,
        chain_liberties,
        chain_perimeter,
        chain_adj_cer_num,
        chain_eye_num,
        chain_eye_sum_size,
        chain_eye_sum_perimeter,
        chain_eye_sum_split_points,
        chain_ext_opp_liberties,
        chain_split_liberties,
        chain_estimated_adj_terr,
        chain_pacer5_num,
        chain_pacer5_ave_power,
        chain_pacer9_num,
        chain_pacer9_ave_power,
        opp_w1_size,
        opp_w1_perimeter,
        opp_w1_liberties,
        opp_w1_shared_liberties,
        opp_w1_atari_liberties,
        opp_w1_chain_connections,
        opp_w1_eye_num,
        opp_w1_eye_sum_size,
        opp_w1_eye_sum_perimeter,
        opp_w1_eye_sum_split_points,
        opp_cw1_size,
        opp_cw1_perimeter,
        opp_cw1_eye_num,
        opp_cw1_eye_sum_size,
        opp_cw1_eye_sum_perimeter,
        opp_cw1_eye_sum_split_points,
        opp_cw1_split_liberties,
        opp_w2_size,
        opp_w2_perimeter,
        opp_w2_liberties,
        opp_w2_shared_liberties,
        opp_w2_atari_liberties,
        opp_w2_chain_connections,
        opp_w2_eye_num,
        opp_w2_eye_sum_size,
        opp_w2_eye_sum_perimeter,
        opp_w2_eye_sum_split_points,
        opp_w3_size,
        opp_w3_perimeter,
        opp_w3_liberties,
        opp_w3_shared_liberties,
        opp_w3_chain_connections,
        opp_w3_eye_num,
        opp_w3_eye_sum_size,
        opp_w3_eye_sum_perimeter,
        opp_w3_eye_sum_split_points,
        fri_s1_size,
        fri_s1_perimeter,
        fri_s1_liberties,
        fri_s1_shared_liberties,
        fri_s1_prot_liberties,
        fri_s1_chain_connections,
        fri_s1_eye_num,
        fri_s1_eye_sum_size,
        fri_s1_eye_sum_perimeter,
        fri_s1_eye_sum_split_points,

        terr_direct_liberties,
        terr_all_friend_liberties,
        terr_all_opp_liberties,

        block_predicted_status,
        chain_ave_predicted_status,
        opp_w1_predicted_status,
        opp_w2_predicted_status,
        opp_w3_predicted_status,
        opp_cw1_ave_predicted_status,
        fri_s1_predicted_status,

        // wanna add something ?
        features_num // = 90
    };

    double fvector[ features_num ];
    double expert_estimate;
    
    int boardId;
    int blockId;
    int x, y;
};

#endif // BLOCK_FEATURES_H_INCLUDED_