//************************************************************************
//   Copyright (C) 2004-2006 Maxim I. Guisov                            //
//                                                                      //
// Permission to use, copy, modify, distribute and sell this software   //
// and its documentation for any purpose is hereby granted without fee, //
// provided that the above copyright notice appear in all copies and    //
// that both that copyright notice and this permission notice appear    //
// in supporting documentation. Author makes no representations         //
// about the suitability of this software for any purpose.              //
// It is provided "as is" without express or implied warranty.          //
//                                                                      //
//************************************************************************
#ifndef RPROPNET_H_INCLUDED_
#define RPROPNET_H_INCLUDED_

#include <vector>
#include "RPropOptimized.h"
#include "..\\Utils\\NetConfig.h"

typedef std::vector<int> NNTopology;
typedef TheNetwork RPropNet;


// singleton
class NetFactory
{
public:
    
    NetFactory( const NetConfig &netConfig ) : netConfig_( netConfig ) {}
    virtual ~NetFactory();

    int CreateNetwork( const NNTopology& topology, const std::string& filename, RPropNet::NetType type );
    void StartBatchTraining();
    void FinishBatchTraining();

    int NetsNumber() const;
    RPropNet* Network( unsigned int index ) const;
    RPropNet* Last() const { return networks.back(); }

private:
    std::vector<RPropNet*> networks;
    const NetConfig &netConfig_;
};

#endif // RPROPNET_H_INCLUDED_