//************************************************************************
//   Copyright (C) 2004-2006 Maxim I. Guisov                            //
//                                                                      //
// Permission to use, copy, modify, distribute and sell this software   //
// and its documentation for any purpose is hereby granted without fee, //
// provided that the above copyright notice appear in all copies and    //
// that both that copyright notice and this permission notice appear    //
// in supporting documentation. Author makes no representations         //
// about the suitability of this software for any purpose.              //
// It is provided "as is" without express or implied warranty.          //
//                                                                      //
//************************************************************************
#ifndef RPROPUTILS_H_INCLUDED_
#define RPROPUTILS_H_INCLUDED_

#include <math.h>

const double n_plus = 1.2;
const double n_minus = 0.5;
const double min_delta = 1e-8;
const double max_delta = 1.0;
const double start_delta = 0.01;

const double sarprop_k1 = 0.01;
const double sarprop_k2 = 0.4;
const double sarprop_k3 = 0.8;


static double min( double x, double y )
{
    return ( x <= y ? x : y );
}

static double max( double x, double y )
{
    return ( x >= y ? x : y );
}

static double sign( double x )
{
    if ( x < 0 ) return -1.0;
    if ( x > 0 ) return 1.0;
    return 0;
}

static double activator( double sum )
{ 
    return 1.0 / ( 1.0 + exp(-sum) );
}

#endif // RPROPUTILS_H_INCLUDED_