//************************************************************************
//   Copyright (C) 2004-2006 Maxim I. Guisov                            //
//                                                                      //
// Permission to use, copy, modify, distribute and sell this software   //
// and its documentation for any purpose is hereby granted without fee, //
// provided that the above copyright notice appear in all copies and    //
// that both that copyright notice and this permission notice appear    //
// in supporting documentation. Author makes no representations         //
// about the suitability of this software for any purpose.              //
// It is provided "as is" without express or implied warranty.          //
//                                                                      //
//************************************************************************
#ifndef IO_LOG_H_INCLUDED_
#define IO_LOG_H_INCLUDED_

//#include <stdio.h>
//
//class LOG
//{
//public:
//   ~LOG();
//
//    static LOG& Instance();
//
//    bool OpenFile( const char* file_name, bool append = false );
//    void Write( const char* string );
//    void CloseFile();
//
//private:
//
//    LOG() : file_(NULL) {}
//
//    FILE* file_;
//};

#include <sstream>
#include <ios>

class LogBase
{
public:

	//static std::string logFilenName_s;
	//static void SetDefaultLog( const std::string& fname );

	LogBase( char level ) : level_(level)
	{ 
		//FILE* fout_ = fopen(logFilenName_s.c_str(), "a");
	}

	template<typename T> LogBase& operator << ( T val )
	{ 
		ostr_ << val;
		return *this; 
	}

	~LogBase()
	{ 
		//fprintf(fout_, "-%c-: %s\n", logLevels_s[level_], ostr_.str().c_str());
		//fclose(fout_);
	}

private:
	std::ostringstream ostr_;
	char level_;
	FILE* fout_;
};

class LogInfo : public LogBase { public: LogInfo() : LogBase('I') {} };
class LogError : public LogBase { public: LogError() : LogBase('E') {} };
class LogWarning : public LogBase { public: LogWarning() : LogBase('W') {} };
class LogTrace : public LogBase { public: LogTrace() : LogBase('T') {} };

#endif // IO_LOG_H_INCLUDED_

