//************************************************************************
//   Copyright (C) 2004-2006 Maxim I. Guisov                            //
//                                                                      //
// Permission to use, copy, modify, distribute and sell this software   //
// and its documentation for any purpose is hereby granted without fee, //
// provided that the above copyright notice appear in all copies and    //
// that both that copyright notice and this permission notice appear    //
// in supporting documentation. Author makes no representations         //
// about the suitability of this software for any purpose.              //
// It is provided "as is" without express or implied warranty.          //
//                                                                      //
//************************************************************************
#ifndef NET_CONFIG_H_INCLUDED_
#define NET_CONFIG_H_INCLUDED_

class NetConfig
{
private:

    bool dropSolved_;
    bool startOnHalf_;
    bool refreshDrop_;
    //bool onlyLastLayer_;
    
public:

    std::vector<int> npVec1i_;
    std::vector<int> npVecNi_;

    NetConfig() : 
        dropSolved_( false ), 
        startOnHalf_( false ), 
        refreshDrop_( false )/*, 
        onlyLastLayer_( false )*/ {}

    bool getDropSolved() const { return dropSolved_; }
    void setDropSolved( bool flag ) { dropSolved_ = flag; }

    bool getStartOnHalfTS() const { return startOnHalf_; }
    void setStartOnHalfTS( bool flag ) { startOnHalf_ = flag; }

    bool getRefreshDrop() const { return refreshDrop_; }
    void setRefreshDrop( bool flag ) { refreshDrop_ = flag; }

    //bool getTrainOnlyOutput() const { return onlyLastLayer_; }
    //void setTrainOnlyOutput( bool flag ) { onlyLastLayer_ = flag; }

    void setNetInputPreset( const std::vector<int> &vec1i, const std::vector<int> &vecNi )
    { 
        npVec1i_.assign( vec1i.begin(), vec1i.end() );
        npVecNi_.assign( vecNi.begin(), vecNi.end() );
    }
};



#endif // NET_CONFIG_H_INCLUDED_
