/************************************************************************
 *   Copyright (C) 2004 Maxim I. Guisov                                 *
 *                                                                      *
 * Permission to use, copy, modify, distribute and sell this software   *
 * and its documentation for any purpose is hereby granted without fee, *
 * provided that the above copyright notice appear in all copies and    *
 * that both that copyright notice and this permission notice appear    *
 * in supporting documentation. Author makes no representations         *
 * about the suitability of this software for any purpose.              *
 * It is provided "as is" without express or implied warranty.          *
 *                                                                      *
 ************************************************************************/

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "SEOG.h"
#include "Utils\\IOSgf.h"

// deprecated function usage warning
#pragma warning ( disable : 4996 )


int main(int argc, char* argv[])
{
    if ( argc < 3 ) {
        printf("need two arguments\n");
        return 0;
    }

    char buffer[32000], str[100];
    if ( !LoadFile( argv[1], buffer )) {
        printf("can't load file\n");
        return 0;
    }

    char* ss = strstr( buffer, "RE[" ), *ps;

    double GameResult = GetGameResult( buffer );
    if ( GameResult == 400 ) {
        printf("wrong game result\n");
        return 0;
    }

    // read board size
    int BoardSize = 0;
    if ( (ss = strstr(buffer, "SZ[")) && (ps = strstr(ss, "]")) && (ps-ss < 100) )
    {
        strncpy(str, ss+3, ps-ss-3); str[ps-ss-3] = 0; BoardSize = atoi(str);
        if ( BoardSize != 19 ) {
            printf("wrong board size\n");
            return 0;
        }
    }
    
    char res_buffer[32000];
    int len = strlen(buffer), c = 0, r = 0;
    int parentnum = 0, bracetnum = 0;
    res_buffer[r++] = '(';
    res_buffer[r++] = ';';

    bool MARKS_PRESENT = false;

    while ( c < len )
    {
        if (buffer[c] == '(') {
            if (bracetnum == 0) parentnum++;
            if (parentnum >= 2) {
                printf("there are variations in this game\n");
                return 0;       // don't analyse variations
            }
            c++;
        }

        else if (buffer[c] == ')') {
            if (parentnum == 1 && bracetnum == 0) parentnum--;
            c++;
        }

        else if (buffer[c] == '[' && bracetnum == 0) {

            if ( (buffer[c-2] == ';' && (buffer[c-1] == 'W' || buffer[c-1] == 'B')) ||
                      (buffer[c-2] == 'S' && buffer[c-1] == 'Z') ||
                      (buffer[c-2] == 'K' && buffer[c-1] == 'M') ||
                      (buffer[c-2] == 'R' && buffer[c-1] == 'E') )
            {
                int len2 = strstr( &buffer[c], "]" ) - &buffer[c] + 3;
                strncpy( &res_buffer[r], &buffer[c-2], len2 ); r+=len2; c+=len2-3;
            }

            else if ( (buffer[c-2] == 'A' && buffer[c-1] == 'B') ||
                      (buffer[c-2] == 'T' && buffer[c-1] == 'B') ||
                      (buffer[c-2] == 'T' && buffer[c-1] == 'W') )
            {
                if ( buffer[c-2] == 'T' ) MARKS_PRESENT = true;
                res_buffer[r++] = buffer[c-2];
                res_buffer[r++] = buffer[c-1];
                while ( buffer[c] == '[' && buffer[c+3] == ']')
                {
                    strncpy( &res_buffer[r], &buffer[c], 4 );
                    r+=4;
                    c+=4;
                }
            } 
            
            else {
                bracetnum++;
                c++;
            }
        }

        else if (buffer[c] == ']' && buffer[c-1] != '\\' && bracetnum == 1) bracetnum--;
        
        else c++;
    }

    res_buffer[r++] = ')';
    res_buffer[r] = 0;

    if ( !MARKS_PRESENT ) {
        printf("unmarked game\n");
    }

    FILE* cofile = fopen("counter.dat", "rt");
    int counter = 0;

    if (cofile) {
        fscanf(cofile, "%d", &counter);
        fclose(cofile);
    }

    cofile = fopen("counter.dat", "wt");
    fprintf(cofile, " %d \n", ++counter);
    fclose(cofile);
  
    char filename[1024];
    sprintf( filename, "%s\\_%.6d.sgb", argv[2], counter );
    FILE* dat = fopen( filename, "wb" );

    if (!dat) {
        printf("can't open file %s for write\n", filename);
        return 0;
    }

    fwrite( res_buffer, 1, r, dat );

    fclose( dat );

    return 0;
}