/************************************************************************
 *   Copyright (C) 2004 Maxim I. Guisov                                 *
 *                                                                      *
 * Permission to use, copy, modify, distribute and sell this software   *
 * and its documentation for any purpose is hereby granted without fee, *
 * provided that the above copyright notice appear in all copies and    *
 * that both that copyright notice and this permission notice appear    *
 * in supporting documentation. Author makes no representations         *
 * about the suitability of this software for any purpose.              *
 * It is provided "as is" without express or implied warranty.          *
 *                                                                      *
 ************************************************************************/

#include <stdio.h>
#include <string.h>
#include <math.h>

#include "SEOG.h"
#include "Navigator\\Boards.h"
#include "Utils\\IOLog.h"
#include "Utils\\IOSgf.h"
#include "Utils\\MorphEngine.h"

// deprecated function usage warning
#pragma warning ( disable : 4996 )


void printBoard( const PowerBoard& pb, const StoneBoard& sb )
{
    for (int r = 0; r < 19; r++)
    {
        for (int c = 0; c < 19 ; c++)
        {
            Point p(c,r);
            char ch = ' ';
            
            switch ( sb.nc_get(p) )
            {
                case eBlack: ch = '*'; break;
                case eWhite: ch = 'o'; break;
                default:
                    if ( pb.nc_get(p) > 0 ) ch = '+'; else
                    if ( pb.nc_get(p) < 0 ) ch = '-'; else
                        ch = '.';
            }

            printf(" %c", ch);
        }
        printf("\n");
    }
}




int main(int argc, char* argv[])
{
    StoneBoard board;
    MarkerBoard expert;
    PowerBoard territory, influence;
    SpPowerBoard power;

    LoadSGF( "_000151.sgf", &board, &expert, 0, 0, 0, 0 );
    
    MorphEngine::EstimateInfluence( &influence, board );
    MorphEngine::EstimateTerritory( &territory, board );
    //MorphEngine::PropagatePower( &power, board );

    // special comby print
    printBoard( influence, board );
    printf("\n\n\n");
    printBoard( territory, board );
    printf("\n\n\n");
    //power.print();

    ScoreEndOfTheGame( &board );

    /*
    int BlackDead, WhiteDead;
    double Komi, Result;
    Board B;

    if ( argc < 2 ) {
        printf( "Specify .sgf file\n" );
        return 0;
    }

    char SgfFileName[256];
    strcpy(SgfFileName, argv[1]);

    if ( !LOG::Instance().OpenFile( "tester_log.txt", true )) {
        printf( "Couldn't open log file\n" );
        return 0;
    }

    if ( !LoadSGF( SgfFileName, &B, NULL, &BlackDead, &WhiteDead, &Komi, &Result ) ) 
    {
        printf( "Couldn't load an sgf file\n" );
        return 0;
    }
    
    int ScoredForBlack = ScoreEndOfTheGame( &B );
    double Difference = (ScoredForBlack + WhiteDead - BlackDead - Komi) - Result;
    
    char buf[512], *fn;
    if ( !(fn = strrchr(SgfFileName, '\\')) ) 
        fn = SgfFileName;
    else fn++;

    sprintf( buf, "[game] %s '%s' result(%g); komi(%g); captured B(%d) and W(%d); scored(%d); difference = %g",
           (fabs(Difference) < 0.1 ? "+" : "-"), fn, Result, Komi, BlackDead, WhiteDead, ScoredForBlack, Difference );
    LOG::Instance().Write( buf );

    LOG::Instance().CloseFile();
*/
    return 0;
}
